/// @cond EO_CXX_EO_IMPL

inline ::elm::widget_item elm::colorselector::palette_color_add(int r_, int g_, int b_, int a_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_color_add(r_, g_, b_, a_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::colorselector::palette_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_colorselector_palette_clear());
}

inline void elm::colorselector::color_get(int* r_, int* g_, int* b_, int* a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_colorselector_color_get(r_, g_, b_, a_));
}

inline void elm::colorselector::color_set(int r_, int g_, int b_, int a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_colorselector_color_set(r_, g_, b_, a_));
}

inline ::efl::eina::string_view elm::colorselector::palette_name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::colorselector::palette_name_set(::efl::eina::string_view palette_name_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_colorselector_palette_name_set(::efl::eolian::to_c(palette_name_)));
}

inline Elm_Colorselector_Mode elm::colorselector::mode_get() const
{
   Elm_Colorselector_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_mode_get());
   return _tmp_ret;
}

inline void elm::colorselector::mode_set(Elm_Colorselector_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_colorselector_mode_set(mode_));
}

inline ::efl::eina::crange_list< Elm_Object_Item * > elm::colorselector::palette_items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Object_Item * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item elm::colorselector::palette_selected_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_selected_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::colorselector::palette_color_add(int r_, int g_, int b_, int a_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_color_add(r_, g_, b_, a_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::colorselector::palette_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_colorselector_palette_clear());
}

inline void eo_cxx::elm::colorselector::color_get(int* r_, int* g_, int* b_, int* a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_colorselector_color_get(r_, g_, b_, a_));
}

inline void eo_cxx::elm::colorselector::color_set(int r_, int g_, int b_, int a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_colorselector_color_set(r_, g_, b_, a_));
}

inline ::efl::eina::string_view eo_cxx::elm::colorselector::palette_name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::colorselector::palette_name_set(::efl::eina::string_view palette_name_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_colorselector_palette_name_set(::efl::eolian::to_c(palette_name_)));
}

inline Elm_Colorselector_Mode eo_cxx::elm::colorselector::mode_get() const
{
   Elm_Colorselector_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::colorselector::mode_set(Elm_Colorselector_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_colorselector_mode_set(mode_));
}

inline ::efl::eina::crange_list< Elm_Object_Item * > eo_cxx::elm::colorselector::palette_items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Object_Item * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::colorselector::palette_selected_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_selected_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::colorselector::operator ::elm::colorselector() const
{
   return *static_cast<::elm::colorselector const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::colorselector::operator ::elm::colorselector&()
{
   return *static_cast<::elm::colorselector*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::colorselector::operator ::elm::colorselector const&() const
{
   return *static_cast<::elm::colorselector const*>(static_cast<void const*>(this));
}

template <typename T>
::elm::widget_item elm_colorselector_palette_color_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int r_, int g_, int b_, int a_)
{
   try
      {
         return static_cast<T*>(self->this_)->palette_color_add(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_colorselector_palette_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->palette_clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_colorselector_color_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* r_, int* g_, int* b_, int* a_)
{
   try
      {
         static_cast<T*>(self->this_)->color_get(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_colorselector_color_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int r_, int g_, int b_, int a_)
{
   try
      {
         static_cast<T*>(self->this_)->color_set(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::string_view elm_colorselector_palette_name_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->palette_name_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_colorselector_palette_name_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * palette_name_)
{
   try
      {
         static_cast<T*>(self->this_)->palette_name_set(::efl::eolian::to_cxx<::efl::eina::string_view>(palette_name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Colorselector_Mode elm_colorselector_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Colorselector_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_colorselector_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Colorselector_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::crange_list< Elm_Object_Item * > elm_colorselector_palette_items_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->palette_items_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Object_Item * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_colorselector_palette_selected_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->palette_selected_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::colorselector >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
         , virtual operations< ::evas::clickable_interface >::template type<T>
   {
      virtual ::elm::widget_item palette_color_add(int r_, int g_, int b_, int a_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_colorselector_palette_color_add(r_, g_, b_, a_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void palette_clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_colorselector_palette_clear());
      }

      virtual void color_get(int* r_, int* g_, int* b_, int* a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_colorselector_color_get(r_, g_, b_, a_));
      }

      virtual void color_set(int r_, int g_, int b_, int a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_colorselector_color_set(r_, g_, b_, a_));
      }

      virtual ::efl::eina::string_view palette_name_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_colorselector_palette_name_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void palette_name_set(::efl::eina::string_view palette_name_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_colorselector_palette_name_set(::efl::eolian::to_c(palette_name_)));
      }

      virtual Elm_Colorselector_Mode mode_get()
      {
         Elm_Colorselector_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_colorselector_mode_get());
            return _tmp_ret;
      }

      virtual void mode_set(Elm_Colorselector_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_colorselector_mode_set(mode_));
      }

      virtual ::efl::eina::crange_list< Elm_Object_Item * > palette_items_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_colorselector_palette_items_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Object_Item * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual ::elm::widget_item palette_selected_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_colorselector_palette_selected_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::colorselector >
{
   static constexpr int value = 
#if defined(COLORSELECTOR_PROTECTED) && defined(COLORSELECTOR_BETA)
      10
#elif defined(COLORSELECTOR_PROTECTED)
      10
#elif defined(COLORSELECTOR_BETA)
      10
#else
      10
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value      + operation_description_class_size<::evas::clickable_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::colorselector>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_colorselector_palette_color_add_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_color_add);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_colorselector_palette_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_colorselector_color_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_color_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_colorselector_color_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_color_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_colorselector_palette_name_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_name_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_colorselector_palette_name_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_name_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_colorselector_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_colorselector_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_colorselector_palette_items_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_items_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_colorselector_palette_selected_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_selected_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::colorselector >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::colorselector >::value + operation_description_class_size<::elm::layout>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::clickable_interface>(), &ops[operation_description_class_size< ::elm::colorselector >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_atspi_widget_action>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::colorselector>)
{
   return (ELM_COLORSELECTOR_CLASS);
}

} } }

/// @endcond

